#pragma once

#include <SDL2/SDL.h>
#include "asset.h"
#include "const.h"
#include "jail_audio.h"
#include "screen.h"
#include "sprite.h"
#include "utils.h"

#ifndef LOGO_H
#define LOGO_H

// Clase Logo
class Logo
{
private:
	// Objetos
	SDL_Renderer *renderer;	 // El renderizador de la ventana
	Screen *screen;			 // Objeto encargado de dibujar en pantalla
	Asset *asset;			 // Objeto que gestiona todos los ficheros de recursos
	LTexture *texture;		 // Textura con los graficos
	SDL_Event *eventHandler; // Manejador de eventos
	Sprite *sprite;			 // Sprite con la textura del logo

	// Variables
	Uint32 ticks;			 // Contador de ticks para ajustar la velocidad del programa
	Uint32 ticksSpeed;		 // Velocidad a la que se repiten los bucles del programa
	section_t section;		 // Estado del bucle principal para saber si continua o se sale
	int counter;			 // Contador

	// Actualiza las variables del objeto
	void update();

	// Dibuja el objeto en pantalla
	void render();

	// Comprueba si ha terminado el logo
	void checkLogoEnd();

	// Comprueba los eventos
	void checkEventHandler();

	// Dibuja el fade
	void renderFade();

public:
	// Constructor
	Logo(SDL_Renderer *renderer, Screen *screen, Asset *mAsset);

	// Destructor
	~Logo();

	// Bucle principal
	section_t run();
};

#endif
